'************************************************
' File:   DebugRegistry.vbs (WSH-Beispiel in VBScript) 
' Autor:  (c) G. Born
'
' Zweck: Das Skript demonstriert den Zugriff auf 
' die Windows-Registrierung in VBscript. Dabei werden
' Laufzeitfehler wegen fehlender Schlssel abgefangen.
' Hier wurde ein Stopp-Befehl eingefhrt, um den Debugger
' aufzurufen.
'************************************************
'
Option Explicit

On Error Resume Next

DIM Root, key, valname, valx, Response, sregval
' Setze Variable 
Root = "HKEY_CLASSES_ROOT"
key = "\.1G_Born\"
valname = "Test"
valx ="Hello World"

' Setze Shell-Object 
Dim WshShell
Set WshShell = WScript.CreateObject("WScript.Shell")

' Benutzerabfrage, ob Schlssel erzeugt werden soll 

 Response = MsgBox("Schlssel einfgen?", vbYesNo + vbQuestion _
           + vbDefaultButton2, "Registrierungszugriff ")

 If Response = vbYes Then           ' Auswahl Ja 
   WshShell.RegWrite Root & Key, "" ' Schlssel/Wert erzeugen 
                                    ' Erfolg anzeigen
   WshShell.Popup "Schlssel " & Root & Key & " erzeugt"
 End If

' ### Stopp-Befehl zum Aufruf des Debuggers
stop

' Benutzerabfrage, ob Wert erzeugt werden soll 
 Response = MsgBox("Wert einfgen?", vbYesNo + vbQuestion _
           + vbDefaultButton2, "Registrierungszugriff")

 If Response = vbYes Then    ' Ja ausgewhlt
                             ' Erzeuge Stringeintrag 
  WSHShell.RegWrite Root & Key & valname, valx, "REG_SZ"
  WSHShell.Popup "Wert " & Root & Key & valname & " gesetzt"
  sregval = WSHShell.RegRead (Root & Key & valname) ' lese Wert
  MsgBox "Wert " & valname & ": " & sregval
 Else
' Versuche Wert zurckzulesen. Falls dieser nicht existiert,
' muss der Fehler ber das err-Objekt abgefangen werden
  sregval = WSHShell.RegRead (Root & Key & valname)
  If err.number <> 0 Then
   MsgBox "Wert existiert nicht"
   WScript.Quit
  Else  
   MsgBox "Wert " & valname & ": " & sregval
  End if
 End If
    
' Vor dem Lschen des Werts nachfragen 
 Response = MsgBox("Wert lschen?", vbYesNo + vbQuestion + _
                    vbDefaultButton2, "Registrierungszugriff")
 If Response = vbYes Then    ' Ja ausgewhlt
  WSHShell.RegDelete Root & Key & valname
  MsgBox "Wert " & valname & " gelscht"
 End If

' Vor dem Lschen des Schlssels fragen
 Response = MsgBox("Lsche Schlssel?", vbYesNo + vbQuestion + _
                    vbDefaultButton2, "Registrierungszugriff")
 If Response = vbYes Then    ' Ja ausgewhlt
  WSHShell.RegDelete Root & Key
  MsgBox "Schlssel " & key & " gelscht"
 End If
'*** Ende